import 'dart:ffi';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:fluttertoast/fluttertoast.dart';

// import 'package:mapbox_gl_example/http/services.dart';
import 'package:flutter_dotenv/flutter_dotenv.dart';
import 'package:get/get.dart';
import 'package:insuideindoor/http/services.dart';
import 'package:insuideindoor/kkk/loading.dart';
import 'package:insuideindoor/models/poi_model.dart';
import 'package:mapbox_gl/mapbox_gl.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:flutter_share/flutter_share.dart';
// import 'package:mapbox_gl_example/models/poi_model.dart';

class MyHome extends StatefulWidget {
  final data;

  const MyHome({Key? key, @required this.data}) : super(key: key);

  @override
  State<MyHome> createState() => _MyHomeState();
}

class _MyHomeState extends State<MyHome> {
  // LatLng? latLngPresent = GetLatLngFromSP();
  double? userLat;
  double? userLong;

  late CameraPosition _initialCameraPosition;

  late MapboxMapController controller;
  bool isLoading = true;
  bool finalBool = true;
  bool finalBool2 = true;
  int? loopCounter;

  GetPoi? poiPoints;
  List<LatLng> poisList = [];
  List<String> poisName = [];
  List<String> poiImage = [];
  LatLng? currentLocationIA;
  bool t1 = false;
  LatLng? dynamicLatLng;
  String? kamalString;
  List<Datum> dataPois = [];
  List<Datum> searchList = [];
  bool? isTerminal2Selected;

  // List<MapMarker> mapMarkerList = [];

  @override
  void initState() {
    super.initState();
    print("widget.data ${widget.data}");
    LatLng aaa = convertToLatLng();
    setState(() {
      isLoading = true;
      finalBool = true;
      finalBool2 = true;
    });
    //LatLng(19.093099, 72.856952)

    fetchPois();
    sharedLatLng().then((value) {
      setState(() {
        _initialCameraPosition = CameraPosition(
            target: dynamicLatLng ?? LatLng(19.098519, 72.874318),
            zoom: 17,
            tilt: 30.0);
      });
    });
    sharedStyleString().then((value) {
      setState(() {
        kamalString = value;
        print("this is kamal string $kamalString");
        finalBool2 = false;
      });
    });
  }

  Future<LatLng> sharedLatLng() async {
    setState(() {
      isLoading = true;
    });
    final SharedPreferences sharedPreferences =
        await SharedPreferences.getInstance();
    bool myisTerminal2Selected =
        sharedPreferences.getBool("isTerminal2Selected") ?? true;
    double latt = sharedPreferences.getDouble('lat') ?? 19.098519;
    double longg = sharedPreferences.getDouble('long') ?? 72.874318;
    print("Final LatLng ${LatLng(latt, longg)}");
    setState(() {
      dynamicLatLng = LatLng(latt, longg);
      finalBool = false;
      isTerminal2Selected = myisTerminal2Selected;
    });
    return LatLng(latt, longg);
  }

  Future<String> sharedStyleString() async {
    setState(() {
      isLoading = true;
    });
    final SharedPreferences sharedPreferences =
        await SharedPreferences.getInstance();
    String styleStringMain = sharedPreferences.getString('styleString') ??
        'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx';

    return styleStringMain;
  }

  LatLng convertToLatLng() {
    String a = widget.data;
    List latlng = a.split(',');
    double _lat = double.parse(latlng[0]);
    double _lng = double.parse(latlng[1]);
    LatLng finalIALatLng = LatLng(_lat, _lng);
    print("finalIALatLng $finalIALatLng");
    return finalIALatLng;
  }

  void _onMapCreated(MapboxMapController mapboxMapController) {
    controller = mapboxMapController;
  }

  fetchPois() async {
    poiPoints = await InternetService().getPOI().then((value) {
      loopCounter = value!.data!.length;
      poisList.clear();
      poisName.clear();

      if (loopCounter! > 0) {
        dataPois = value!.data! ?? [];
        setState(() {});
      }

      for (int a = 1; a <= loopCounter!; a++) {
        // print("latlng ${a - 1} is : ${value.data![a - 1].lat}");
        poisList.insert(
            a - 1, LatLng(value.data![a - 1].lat!, value.data![a - 1].lng!));

        poisName.insert(
            a - 1, value.data?[a - 1].poiMultilingual!.en!.name ?? "Test");
        poiImage.insert(
            a - 1, value.data?[a - 1].subcategory.toString() ?? "EMPTY");
      }
      return null;
    });
    if (!mounted) return;
    setState(() {
      isLoading = false;
    });
  }

  customPOIbasedonLevelId(levelId) async {
    poiPoints = await InternetService().getPOI().then((value) {
      loopCounter = value!.data!.length;
      // print("levelid ${value.data![0].levelid}");
      poisList.clear();
      poisName.clear();
      for (int a = 1; a <= loopCounter!; a++) {
        if (value.data![0].levelid == levelId) {
          poisList.insert(
              a - 1, LatLng(value.data![a - 1].lat!, value.data![a - 1].lng!));

          poisName.insert(
              a - 1, value.data?[a - 1].poiMultilingual!.en!.name ?? "Test");
        }
      }
      return null;
    });
    if (!mounted) return;
    setState(() {
      isLoading = false;
    });
  }

  customPOIbasedontTERMINALId(levelId) async {
    poiPoints = await InternetService().getPOI().then((value) {
      loopCounter = value!.data!.length;
      // print("levelid ${value.data![0].levelid}");
      poisList.clear();
      poisName.clear();
      for (int a = 1; a <= loopCounter!; a++) {
        if (value.data![0].terminal == levelId) {
          poisList.insert(
              a - 1, LatLng(value.data![a - 1].lat!, value.data![a - 1].lng!));
          poisName.insert(
              a - 1, value.data?[a - 1].poiMultilingual!.en!.name ?? "Test");
        }
      }
      return null;
    });
    if (!mounted) return;
    setState(() {
      isLoading = false;
    });
  }

  ///THE ABOVE 2 FUNCTIONS CAN BE CLUBBED IN ONE

  tappedaFunction(Symbol symbol) {
    print("print $symbol");

    Fluttertoast.showToast(
      msg: 'Tapped on POI',
      // backgroundColor: Colors.black,
      // textColor: whiteColor,
    );
  }

  void addSymbol(MapboxMapController mapBoxController) {
    for (int a = 0; a < loopCounter!; a++) {
      const POIIcon = {};

      String iconReturn() {
        if (poiImage[a] == "restaurant" ||
            poiImage[a] == "bar" ||
            poiImage[a] == "cafe" ||
            poiImage[a] == "fast food") {
          return "assets/symbols/restro.png";
        } else if (poiImage[a] == "clothing") {
          return "assets/symbols/clothing.png";
        } else if (poiImage[a] == "bar") {
          return "assets/symbols/restro.png";
        } else if (poiImage[a] == "travel & books") {
          return "assets/symbols/travelbook.png";
        } else if (poiImage[a] == "electronics") {
          //to be updated
          return "assets/symbols/travelbook.png";
        } else if (poiImage[a] == "gifts & toys") {
          return "assets/symbols/gift.png";
        } else if (poiImage[a] == "atm") {
          return "assets/symbols/atm.png";
        } else if (poiImage[a] == "Currency exchange") {
          return "assets/symbols/currencyexchange.png";
        } else if (poiImage[a] == "Lounge") {
          return "assets/symbols/lounge.png";
        } else if (poiImage[a] == "Telephone") {
          return "assets/symbols/telephone.png";
        } else if (poiImage[a] == "Children's play area") {
          return "assets/symbols/playarea.png";
        } else if (poiImage[a] == "Ticket counter") {
          return "assets/symbols/ticketcounter.png";
        } else if (poiImage[a] == "Tourism") {
          return "assets/symbols/tourism.png";
        } else if (poiImage[a] == "Post office") {
          return "assets/symbols/postoffice.png";
        } else if (poiImage[a] == "Baby changing room ") {
          return "assets/symbols/babychange.png";
        } else if (poiImage[a] == "Baggage claim") {
          return "assets/symbols/baggageclaim.png";
        } else if (poiImage[a] == "bus") {
          return "assets/symbols/bus.png";
        } else if (poiImage[a] == "car") {
          return "assets/symbols/car.png";
        } else if (poiImage[a] == "Check-in counters") {
          return "assets/symbols/checkin.png";
        } else if (poiImage[a] == "Customs") {
          return "assets/symbols/customs.png";
        } else if (poiImage[a] == "Escalator") {
          return "assets/symbols/escalator.png";
        } else if (poiImage[a] == "Exit") {
          return "assets/symbols/exit.png";
        } else if (poiImage[a] == "Gates") {
          //TO BE CHANGED
          return "assets/symbols/postoffice.png";
        } else if (poiImage[a] == "FIDS") {
          //TO BE CHANGED
          return "assets/symbols/postoffice.png";
        } else if (poiImage[a] == "Lift") {
          return "assets/symbols/lift.png";
        } else if (poiImage[a] == "Lost and found") {
          return "assets/symbols/lostandfound.png";
        } else if (poiImage[a] == "Metro") {
          return "assets/symbols/metro.png";
        } else if (poiImage[a] == "Passport control") {
          return "assets/symbols/passport.png";
        } else if (poiImage[a] == "Charging") {
          return "assets/symbols/charging.png";
        } else if (poiImage[a] == "Prayer room") {
          return "assets/symbols/prayer.png";
        } else if (poiImage[a] == "security screening") {
          return "assets/symbols/security.png";
        } else if (poiImage[a] == "smoking room") {
          return "assets/symbols/smoking.png";
        } else if (poiImage[a] == "staircase") {
          return "assets/symbols/stairs.png";
        } else if (poiImage[a] == "toilet") {
          return "assets/symbols/charging.png";
        } else if (poiImage[a] == "train") {
          return "assets/symbols/train.png";
        } else if (poiImage[a] == "transit") {
          return "assets/symbols/transit.png";
        } else if (poiImage[a] == "drinking water") {
          //TO BE CHANGEd
          return "assets/symbols/charging.png";
        } else if (poiImage[a] == "emergency exit") {
          return "assets/symbols/exit.png";
        } else if (poiImage[a] == "medical") {
          return "assets/symbols/medical.png";
        } else if (poiImage[a] == "female toilet") {
          return "assets/symbols/femaletoilet.png";
        } else if (poiImage[a] == "male toilet") {
          return "assets/symbols/toilet.png";
        } else if (poiImage[a] == "disabled toilet") {
          return "assets/symbols/disabled.png";
        } else if (poiImage[a] == "Help desk") {
          return "assets/symbols/helpdesk.png";
        } else {
          return "assets/symbols/helpdesk.png";
          // return "assets/symbols/neww.png";
        }
      }

      mapBoxController.addSymbol(
        SymbolOptions(
            geometry: poisList[a],
            iconImage: iconReturn(),
            iconSize: 2.5,
            textField: poisName[a],
            textSize: 15,
            iconOffset: const Offset(0, -30)),
      );
    }
    mapBoxController.onSymbolTapped.add(tappedaFunction);

    //SHOWING CURRENT USER LOCATION ON MAP
    mapBoxController.addSymbol(
      SymbolOptions(
        // geometry: LatLng(19.093099, 72.856952),
        geometry: convertToLatLng(),

        iconImage: "assets/symbols/Oval.png",
        iconSize: 3,
      ),
    );
    mapBoxController.onSymbolTapped.add(tappedaFunction);
  }

  var styleString =
      'mapbox://styles/merrillgonsalves/cl5ez27io005p14rz5aqp8234';

  var t1l1 = 'mapbox://styles/merrillgonsalves/cl5ez27io005p14rz5aqp8234';
  var t1l2 = 'mapbox://styles/merrillgonsalves/cl5ez2lht002214s0ow0ghr8z';
  var t1l3 = 'mapbox://styles/merrillgonsalves/cl5l2hq6w001o15nxfhzighuw';

  var t2l1 = 'mapbox://styles/merrillgonsalves/cl5ez2e9l000j14r0y08curhk';
  var t2l2 = 'mapbox://styles/merrillgonsalves/cl5ez205n002h14pvay28t8iz';
  var t2l3 = 'mapbox://styles/merrillgonsalves/cl5c9c84e006o14nu2a8sny58';
  var t2l4 = 'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx';

  @override
  Widget build(BuildContext context) {
    const Channel = MethodChannel("com.mapbox.mapboxglexample");
    const platform = const MethodChannel("com.mapbox.mapboxglexample");

    platform.setMethodCallHandler((call) async {
      print("init state setMethodCallHandler ${call.arguments}");
      setState(() {
        // _initialCameraPosition =
        //     CameraPosition(target: convertToLatLng(), zoom: 17, tilt: 30.0);
      });
      ScaffoldMessenger.of(context).showSnackBar(
        SnackBar(
          content: Text(convertToLatLng().toString()),
        ),
      );
    });
    // setState(() {
    //   _initialCameraPosition =
    //       CameraPosition(target: convertToLatLng(), zoom: 17, tilt: 30.0);
    //   ScaffoldMessenger.of(context).showSnackBar(
    //     SnackBar(
    //       content: Text(widget.data),
    //     ),
    //   );
    // });
    double myHeight = MediaQuery.of(context).size.height / 3.8;
    double myBigHeight = MediaQuery.of(context).size.height - myHeight - 100;
    double width = MediaQuery.of(context).size.width;
    double height = MediaQuery.of(context).size.height;
    double btnPadding = 10.0;
    double btnSize = 25.0;
    double fontSize = 16.0;
    Future<void> shareRestro(String title, String location) async {
      await FlutterShare.share(
        title: title,
        text: location,
      );
    }

    return Scaffold(
      body: finalBool && finalBool2
          ? const Center(child: CircularProgressIndicator())
          : SafeArea(
              child: Container(
              width: width,
              height: height,
              child: Stack(
                children: [
                  SizedBox(
                    child: isLoading
                        ? Center(
                            child: Column(
                              mainAxisAlignment: MainAxisAlignment.center,
                              children: [
                                CircularProgressIndicator(),
                                SizedBox(
                                  height: 20,
                                ),
                                Text("Loading POI's & IA Location")
                              ],
                            ),
                          )
                        : Stack(
                            children: [
                              SizedBox(
                                height: myBigHeight,
                                child: Stack(
                                  alignment: Alignment.bottomCenter,
                                  children: [
                                    Container(
                                      height: myBigHeight,
                                      child: MapboxMap(
                                        tiltGesturesEnabled: true,
                                        accessToken:
                                            dotenv.env['MAPBOX_ACCESS_TOKEN'],
                                        initialCameraPosition:
                                            _initialCameraPosition,
                                        onMapCreated: _onMapCreated,
                                        trackCameraPosition: true,
                                        onCameraTrackingChanged: (mode) {
                                          // print("mode.name ${mode}");
                                          // print("mode.name ${mode.name}");
                                        },

                                        onStyleLoadedCallback: () =>
                                            addSymbol(controller),
                                        // myLocationEnabled: true,
                                        myLocationTrackingMode:
                                            MyLocationTrackingMode.TrackingGPS,
                                        // minMaxZoomPreference:
                                        //     const MinMaxZoomPreference(14, 17),
                                        annotationOrder: [
                                          AnnotationType.symbol
                                        ],
                                        styleString: kamalString,
                                      ),
                                    ),
                                    Container(
                                      margin:
                                          EdgeInsets.only(left: 20, right: 20),
                                      padding: EdgeInsets.only(bottom: 10),
                                      child: Row(
                                        crossAxisAlignment:
                                            CrossAxisAlignment.end,
                                        mainAxisAlignment:
                                            MainAxisAlignment.spaceBetween,
                                        children: [
                                          GestureDetector(
                                            onTap: () {
                                              controller.animateCamera(
                                                  CameraUpdate.newCameraPosition(
                                                      CameraPosition(
                                                          target:
                                                              convertToLatLng())));
                                            },
                                            child: Container(
                                              padding:
                                                  EdgeInsets.all(btnPadding),
                                              decoration: BoxDecoration(
                                                  color: Colors.white,
                                                  borderRadius:
                                                      BorderRadius.circular(
                                                          10)),
                                              child: Image.asset(
                                                "assets/images/location.png",
                                                width: btnSize,
                                                height: btnSize,
                                              ),
                                            ),
                                          ),
                                          GestureDetector(
                                            onTap: () {
                                              print("TAPPED ON SHARE");
                                              shareRestro("Insuide Maps",
                                                  "We'll share your location here");
                                            },
                                            child: Column(
                                              mainAxisSize: MainAxisSize.min,
                                              children: [
                                                Container(
                                                  padding: EdgeInsets.all(
                                                      btnPadding),
                                                  decoration: BoxDecoration(
                                                      color: Colors.white,
                                                      borderRadius:
                                                          BorderRadius.only(
                                                              topLeft: Radius
                                                                  .circular(7),
                                                              topRight: Radius
                                                                  .circular(
                                                                      7))),
                                                  child: Image.asset(
                                                    "assets/images/navigate.png",
                                                    width: btnSize,
                                                    height: btnSize,
                                                  ),
                                                ),
                                                SizedBox(
                                                  height: 1,
                                                ),
                                                GestureDetector(
                                                  onTap: () {
                                                    showModalBottomSheet<void>(
                                                      context: context,
                                                      builder: (BuildContext
                                                          context) {
                                                        return Container(
                                                          decoration: const BoxDecoration(
                                                              color:
                                                                  Colors.white,
                                                              borderRadius: BorderRadius.only(
                                                                  topLeft: Radius
                                                                      .circular(
                                                                          50),
                                                                  topRight: Radius
                                                                      .circular(
                                                                          50))),
                                                          child: Padding(
                                                            padding:
                                                                const EdgeInsets
                                                                    .all(10.0),
                                                            child:
                                                                SingleChildScrollView(
                                                              child: Column(
                                                                crossAxisAlignment:
                                                                    CrossAxisAlignment
                                                                        .start,
                                                                children: [
                                                                  Align(
                                                                    alignment:
                                                                        Alignment
                                                                            .center,
                                                                    child:
                                                                        Container(
                                                                      width:
                                                                          width *
                                                                              0.2,
                                                                      height: 5,
                                                                      decoration: BoxDecoration(
                                                                          color: Color(
                                                                              0xffEAEBED),
                                                                          borderRadius:
                                                                              BorderRadius.circular(10.0)),
                                                                    ),
                                                                  ),
                                                                  GestureDetector(
                                                                    onTap: () {
                                                                      Navigator.pop(
                                                                          context);
                                                                    },
                                                                    child: Icon(
                                                                        Icons
                                                                            .close),
                                                                  ),
                                                                  TextButton(
                                                                      onPressed:
                                                                          () async {
                                                                        final SharedPreferences
                                                                            sharedPreferences =
                                                                            await SharedPreferences.getInstance();
                                                                        sharedPreferences.setDouble(
                                                                            'lat',
                                                                            19.092067);
                                                                        sharedPreferences.setDouble(
                                                                            'long',
                                                                            72.853808);
                                                                        sharedPreferences.setString(
                                                                            'styleString',
                                                                            'mapbox://styles/merrillgonsalves/cl5l2hq6w001o15nxfhzighuw');
                                                                        Get.off(
                                                                            Loading());

                                                                        // controller
                                                                        //     .dispose();

                                                                        if (isTerminal2Selected ??
                                                                            true) {
                                                                          setState(
                                                                              () {
                                                                            sharedPreferences.setBool('isTerminal2Selected',
                                                                                false);
                                                                          });
                                                                        } else {
                                                                          setState(
                                                                              () {
                                                                            sharedPreferences.setBool('isTerminal2Selected',
                                                                                true);
                                                                          });
                                                                        }
                                                                      },
                                                                      child: Text(
                                                                          "Terminal 1",
                                                                          style: !isTerminal2Selected!
                                                                              ? TextStyle(color: Colors.black, fontWeight: FontWeight.bold)
                                                                              : TextStyle(color: Colors.black))),
                                                                  TextButton(
                                                                      onPressed:
                                                                          () async {
                                                                        final SharedPreferences
                                                                            sharedPreferences =
                                                                            await SharedPreferences.getInstance();
                                                                        sharedPreferences.setDouble(
                                                                            'lat',
                                                                            19.098519);
                                                                        sharedPreferences.setDouble(
                                                                            'long',
                                                                            72.874318);
                                                                        sharedPreferences.setString(
                                                                            'styleString',
                                                                            'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx');
                                                                        Get.off(
                                                                            Loading());
                                                                        // controller
                                                                        //     .dispose();

                                                                        if (isTerminal2Selected ??
                                                                            true) {
                                                                          setState(
                                                                              () async {
                                                                            await sharedPreferences.setBool("isTerminal2Selected",
                                                                                false);
                                                                          });
                                                                        } else {
                                                                          setState(
                                                                              () async {
                                                                            await sharedPreferences.setBool("isTerminal2Selected",
                                                                                true);
                                                                          });
                                                                        }
                                                                      },
                                                                      child: Text(
                                                                          "Terminal 2",
                                                                          style: isTerminal2Selected ?? true
                                                                              ? TextStyle(color: Colors.black, fontWeight: FontWeight.bold)
                                                                              : TextStyle(color: Colors.black))),
                                                                ],
                                                              ),
                                                            ),
                                                          ),
                                                        );
                                                      },
                                                    );
                                                  },
                                                  child: Container(
                                                    padding: EdgeInsets.all(
                                                        btnPadding),
                                                    decoration: BoxDecoration(
                                                        color: Colors.white,
                                                        borderRadius:
                                                            BorderRadius.only(
                                                                bottomLeft: Radius
                                                                    .circular(
                                                                        7),
                                                                bottomRight:
                                                                    Radius
                                                                        .circular(
                                                                            7))),
                                                    child: Image.asset(
                                                      "assets/images/terminal.png",
                                                      width: btnSize,
                                                      height: btnSize,
                                                    ),
                                                  ),
                                                ),
                                                SizedBox(
                                                  height: 1,
                                                ),
                                                GestureDetector(
                                                  onTap: () {
                                                    showModalBottomSheet<void>(
                                                      context: context,
                                                      builder: (BuildContext
                                                          context) {
                                                        return Container(
                                                          decoration: const BoxDecoration(
                                                              color:
                                                                  Colors.white,
                                                              borderRadius: BorderRadius.only(
                                                                  topLeft: Radius
                                                                      .circular(
                                                                          50),
                                                                  topRight: Radius
                                                                      .circular(
                                                                          50))),
                                                          child: Padding(
                                                            padding:
                                                                const EdgeInsets
                                                                    .all(10.0),
                                                            child:
                                                                SingleChildScrollView(
                                                              child: Column(
                                                                crossAxisAlignment:
                                                                    CrossAxisAlignment
                                                                        .start,
                                                                children: [
                                                                  TextButton(
                                                                      onPressed:
                                                                          () {
                                                                        // styleString =
                                                                        //     "mapbox://styles/merrillgonsalves/cl5ez27io005p14rz5aqp8234";
                                                                        // setState(() {});

                                                                        // customPOIbasedontTERMINALId(
                                                                        //         1)
                                                                        //     .then((value) {
                                                                        //   controller.animateCamera(
                                                                        //       CameraUpdate.newCameraPosition(CameraPosition(
                                                                        //           target: LatLng(
                                                                        //               72.85610889365556,
                                                                        //               19.09214918115378),
                                                                        //           zoom: 17,
                                                                        //           tilt: 30.0)));
                                                                        // });

                                                                        // controller.animateCamera(CameraUpdate.newCameraPosition(CameraPosition(
                                                                        //     target: LatLng(
                                                                        //         19.09214918115378,
                                                                        //         72.85610889365556),
                                                                        //     zoom: 17,
                                                                        //     tilt: 30.0)));

                                                                        Navigator.pop(
                                                                            context);
                                                                        // void addSymbol(
                                                                        //     MapboxMapController
                                                                        //         mapBoxController) {
                                                                        //   mapBoxController
                                                                        //       .addSymbol(
                                                                        //     SymbolOptions(
                                                                        //       geometry: LatLng(
                                                                        //           19.09214918115378,
                                                                        //           72.85610889365556),
                                                                        //       iconImage:
                                                                        //           "assets/symbols/Oval.png",
                                                                        //       iconSize: 3,
                                                                        //     ),
                                                                        //   );
                                                                        // }

                                                                        _body(
                                                                            t1l1);
                                                                      },
                                                                      child: Text(
                                                                          "Terminal 1")),
                                                                  TextButton(
                                                                      onPressed:
                                                                          () {
                                                                        // styleString =
                                                                        //     "mapbox://styles/merrillgonsalves/cl5ez2lht002214s0ow0ghr8z";
                                                                        // setState(() {});
                                                                        // setState(() {
                                                                        //   isLoading = true;
                                                                        // });
                                                                        // customPOIbasedontTERMINALId(
                                                                        //     2);
                                                                        // controller.animateCamera(CameraUpdate.newCameraPosition(CameraPosition(
                                                                        //     target: LatLng(
                                                                        //         19.099013794366645,
                                                                        //         72.87337468789997),
                                                                        //     zoom: 17,
                                                                        //     tilt: 30.0)));
                                                                        // void addSymbol(
                                                                        //     MapboxMapController
                                                                        //         mapBoxController) {
                                                                        //   mapBoxController
                                                                        //       .addSymbol(
                                                                        //     SymbolOptions(
                                                                        //       geometry:
                                                                        //           LatLng(
                                                                        //         19.099013794366645,
                                                                        //         72.87337468789997,
                                                                        //       ),
                                                                        //       iconImage:
                                                                        //           "assets/symbols/Oval.png",
                                                                        //       iconSize: 3,
                                                                        //     ),
                                                                        //   );
                                                                        // }

                                                                        Navigator.pop(
                                                                            context);
                                                                        _body(
                                                                            t2l1);
                                                                      },
                                                                      child: Text(
                                                                          "Terminal 2")),
                                                                ],
                                                              ),
                                                            ),
                                                          ),
                                                        );
                                                      },
                                                    );
                                                  },
                                                  child: GestureDetector(
                                                    onTap: () {
                                                      showModalBottomSheet<
                                                          void>(
                                                        context: context,
                                                        builder: (BuildContext
                                                            context) {
                                                          return Container(
                                                            decoration: const BoxDecoration(
                                                                color: Colors
                                                                    .white,
                                                                borderRadius: BorderRadius.only(
                                                                    topLeft: Radius
                                                                        .circular(
                                                                            50),
                                                                    topRight: Radius
                                                                        .circular(
                                                                            50))),
                                                            child: Padding(
                                                              padding:
                                                                  const EdgeInsets
                                                                          .all(
                                                                      10.0),
                                                              child:
                                                                  SingleChildScrollView(
                                                                child: Column(
                                                                  crossAxisAlignment:
                                                                      CrossAxisAlignment
                                                                          .start,
                                                                  children: [
                                                                    Align(
                                                                      alignment:
                                                                          Alignment
                                                                              .center,
                                                                      child:
                                                                          Container(
                                                                        width: width *
                                                                            0.2,
                                                                        height:
                                                                            5,
                                                                        decoration: BoxDecoration(
                                                                            color:
                                                                                Color(0xffEAEBED),
                                                                            borderRadius: BorderRadius.circular(10.0)),
                                                                      ),
                                                                    ),
                                                                    GestureDetector(
                                                                      onTap:
                                                                          () {
                                                                        Navigator.pop(
                                                                            context);
                                                                      },
                                                                      child: Icon(
                                                                          Icons
                                                                              .close),
                                                                    ),
                                                                    Visibility(
                                                                      visible:
                                                                          !isTerminal2Selected!,
                                                                      child: TextButton(
                                                                          onPressed: () async {
                                                                            final SharedPreferences
                                                                                sharedPreferences =
                                                                                await SharedPreferences.getInstance();
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.093099);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.856952);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5ez27io005p14rz5aqp8234');
                                                                            Get.off(Loading());

                                                                            controller.dispose();
                                                                          },
                                                                          child: Text("Level 0")),
                                                                    ),
                                                                    TextButton(
                                                                        onPressed:
                                                                            () async {
                                                                          final SharedPreferences
                                                                              sharedPreferences =
                                                                              await SharedPreferences.getInstance();
                                                                          bool
                                                                              _myCheckBool =
                                                                              sharedPreferences.getBool("isTerminal2Selected") ?? true;
                                                                          if (_myCheckBool) {
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.099474);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.874330);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5ez2e9l000j14r0y08curhk');
                                                                            Get.off(Loading());

                                                                            controller.dispose();
                                                                          } else {
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.092141);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.855159);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5ez2lht002214s0ow0ghr8z');
                                                                          }

                                                                          print(
                                                                              "TAPPED IN LEVEL 1");
                                                                        },
                                                                        child: Text(
                                                                            "Level 1")),
                                                                    TextButton(
                                                                        onPressed:
                                                                            () async {
                                                                          final SharedPreferences
                                                                              sharedPreferences =
                                                                              await SharedPreferences.getInstance();
                                                                          bool
                                                                              myCheckBool =
                                                                              sharedPreferences.getBool("isTerminal2Selected") ?? true;
                                                                          if (myCheckBool) {
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.098588);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.874341);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5ez205n002h14pvay28t8iz');
                                                                            Get.off(Loading());
                                                                            controller.dispose();
                                                                          } else {
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.092067);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.853808);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5l2hq6w001o15nxfhzighuw');
                                                                            Get.off(Loading());
                                                                            controller.dispose();
                                                                          }

                                                                          // Navigator.pop(
                                                                          //     context);
                                                                          print(
                                                                              "TAPPED IN LEVEL 2");
                                                                        },
                                                                        child: Text(
                                                                            "Level 2")),
                                                                    Visibility(
                                                                      visible:
                                                                          isTerminal2Selected!,
                                                                      child: TextButton(
                                                                          onPressed: () async {
                                                                            final SharedPreferences
                                                                                sharedPreferences =
                                                                                await SharedPreferences.getInstance();
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.096827);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.874386);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl5c9c84e006o14nu2a8sny58');
                                                                            Get.off(Loading());
                                                                            controller.dispose();
                                                                          },
                                                                          child: Text("Level 3")),
                                                                    ),
                                                                    Visibility(
                                                                      visible:
                                                                          isTerminal2Selected!,
                                                                      child: TextButton(
                                                                          onPressed: () async {
                                                                            final SharedPreferences
                                                                                sharedPreferences =
                                                                                await SharedPreferences.getInstance();
                                                                            sharedPreferences.setDouble('lat',
                                                                                19.098519);
                                                                            sharedPreferences.setDouble('long',
                                                                                72.874318);
                                                                            sharedPreferences.setString('styleString',
                                                                                'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx');
                                                                            Get.off(Loading());
                                                                            controller.dispose();
                                                                          },
                                                                          child: Text("Level 4")),
                                                                    ),
                                                                  ],
                                                                ),
                                                              ),
                                                            ),
                                                          );
                                                        },
                                                      );
                                                    },
                                                    child: Container(
                                                      padding: EdgeInsets.all(
                                                          btnPadding),
                                                      decoration: BoxDecoration(
                                                          color: Colors.white,
                                                          borderRadius:
                                                              BorderRadius.only(
                                                                  topLeft: Radius
                                                                      .circular(
                                                                          7),
                                                                  topRight: Radius
                                                                      .circular(
                                                                          7))),
                                                      child: Image.asset(
                                                        "assets/images/layers.png",
                                                        width: btnSize,
                                                        height: btnSize,
                                                      ),
                                                    ),
                                                  ),
                                                ),
                                              ],
                                            ),
                                          ),
                                        ],
                                      ),
                                    ),
                                  ],
                                ),
                              ),
                              DraggableScrollableSheet(
                                  initialChildSize: 0.387,
                                  minChildSize: 0.387,
                                  maxChildSize: 1,
                                  snap: true,
                                  snapSizes: [0.387, 1],
                                  builder: (BuildContext context,
                                      scrollSheetController) {
                                    return Container(
                                        decoration: BoxDecoration(
                                            color: Colors.white,
                                            borderRadius: BorderRadius.all(
                                                Radius.circular(16.0))),
                                        child: ListView.builder(
                                            padding: EdgeInsets.zero,
                                            physics: ClampingScrollPhysics(),
                                            // physics: ClampingScrollPhysics(),
                                            controller: scrollSheetController,
                                            itemCount: 1,
                                            itemBuilder: (BuildContext context,
                                                int index) {
                                              return Column(
                                                children: [
                                                  const SizedBox(height: 8),
                                                  Container(
                                                    width: width * 0.2,
                                                    height: 5,
                                                    decoration: BoxDecoration(
                                                        color:
                                                            Color(0xffEAEBED),
                                                        borderRadius:
                                                            BorderRadius
                                                                .circular(
                                                                    10.0)),
                                                  ),
                                                  const SizedBox(height: 15),
                                                  Container(
                                                    margin: const EdgeInsets
                                                            .symmetric(
                                                        horizontal: 20),
                                                    padding: const EdgeInsets
                                                        .symmetric(vertical: 0),
                                                    decoration: BoxDecoration(
                                                        color:
                                                            Color(0xffEAEBED),
                                                        borderRadius:
                                                            BorderRadius
                                                                .circular(40)),
                                                    child: TextFormField(
                                                      scrollPadding:
                                                          EdgeInsets.zero,
                                                      decoration:
                                                          InputDecoration(
                                                        // fillColor: Color(0xffEAEBED),
                                                        isDense: true,
                                                        contentPadding:
                                                            const EdgeInsets
                                                                .all(0.0),
                                                        prefixIcon: Icon(
                                                            Icons.search,
                                                            size: btnSize,
                                                            color: Color(
                                                                0xFF555555)),
                                                        suffixIcon: Icon(
                                                          Icons.directions,
                                                          size: btnSize,
                                                          color:
                                                              Color(0xFF555555),
                                                        ),
                                                        hintText: "Search",
                                                        hintStyle:
                                                            const TextStyle(
                                                                fontWeight:
                                                                    FontWeight
                                                                        .bold,
                                                                fontSize: 15),
                                                        border: OutlineInputBorder(
                                                            borderRadius:
                                                                BorderRadius
                                                                    .circular(
                                                                        40),
                                                            borderSide: BorderSide(
                                                                color: Color(
                                                                    0xffEAEBED))),
                                                        disabledBorder: OutlineInputBorder(
                                                            borderRadius:
                                                                BorderRadius
                                                                    .circular(
                                                                        40),
                                                            borderSide: BorderSide(
                                                                color: Color(
                                                                    0xffEAEBED))),
                                                        enabledBorder: OutlineInputBorder(
                                                            borderRadius:
                                                                BorderRadius
                                                                    .circular(
                                                                        40),
                                                            borderSide: BorderSide(
                                                                color: Color(
                                                                    0xffEAEBED))),
                                                        focusedBorder: OutlineInputBorder(
                                                            borderRadius:
                                                                BorderRadius
                                                                    .circular(
                                                                        40),
                                                            borderSide: BorderSide(
                                                                color: Color(
                                                                    0xffEAEBED))),
                                                      ),
                                                      // onTap: () {
                                                      //   readOnly = !readOnly;
                                                      //   setState(() {});
                                                      // },
                                                      onChanged: (text) {
                                                        if (text.isNotEmpty) {
                                                          searchList.clear();
                                                          for (int i = 0;
                                                              i <
                                                                  dataPois
                                                                      .length;
                                                              i++) {
                                                            Datum d =
                                                                dataPois[i];
                                                            print(
                                                                "dil ${d.appname}");
                                                            if (d.category
                                                                    .toString()
                                                                    .toLowerCase()
                                                                    .contains(
                                                                        text) ||
                                                                d.subcategory
                                                                    .toString()
                                                                    .toLowerCase()
                                                                    .contains(
                                                                        text)) {
                                                              searchList.add(d);
                                                            }
                                                          }
                                                          // searchList = dataPois
                                                          //     .where((element) =>
                                                          //         element.category
                                                          //             .toString()
                                                          //             .toLowerCase()
                                                          //             .contains(text) ||
                                                          //         element.subcategory
                                                          //             .toString()
                                                          //             .toLowerCase()
                                                          //             .contains(text))
                                                          //     .toList();
                                                          setState(() {});
                                                        }
                                                      },
                                                      // autofocus: true,
                                                      // readOnly: readOnly,
                                                    ),
                                                  ),
                                                  Stack(
                                                    children: [
                                                      Column(
                                                        mainAxisSize:
                                                            MainAxisSize.min,
                                                        children: [
                                                          const SizedBox(
                                                              height: 10),
                                                          // Row(
                                                          //   mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                                                          //   children: const [],
                                                          // ),
                                                          // const SizedBox(height: 10),
                                                          SizedBox(
                                                            // height: myHeight - 48,
                                                            child:
                                                                SingleChildScrollView(
                                                              padding: const EdgeInsets
                                                                      .symmetric(
                                                                  horizontal:
                                                                      20),
                                                              child: Column(
                                                                mainAxisAlignment:
                                                                    MainAxisAlignment
                                                                        .start,
                                                                crossAxisAlignment:
                                                                    CrossAxisAlignment
                                                                        .start,
                                                                children: [
                                                                  // SizedBox(height: 5),
                                                                  Text(
                                                                    "Explore",
                                                                    style: TextStyle(
                                                                        fontSize:
                                                                            fontSize,
                                                                        fontStyle:
                                                                            FontStyle.italic),
                                                                  ),
                                                                  const SizedBox(
                                                                      height:
                                                                          15),
                                                                  Row(
                                                                      mainAxisAlignment:
                                                                          MainAxisAlignment
                                                                              .spaceAround,
                                                                      children: [
                                                                        Column(
                                                                          mainAxisAlignment:
                                                                              MainAxisAlignment.start,
                                                                          crossAxisAlignment:
                                                                              CrossAxisAlignment.start,
                                                                          children: [
                                                                            Row(
                                                                              mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                                                              children: [
                                                                                Image.asset(
                                                                                  // "assets/symbols/Oval.png",
                                                                                  "assets/images/restro2.png",
                                                                                  // "assets/symbols/neww.png",
                                                                                  height: 30,
                                                                                  width: 30,
                                                                                ),
                                                                                const SizedBox(width: 10),
                                                                                Text(
                                                                                  "Restaurants",
                                                                                  style: TextStyle(fontSize: fontSize),
                                                                                )
                                                                              ],
                                                                            ),
                                                                            const SizedBox(
                                                                              height: 15,
                                                                            ),
                                                                            Row(
                                                                              children: [
                                                                                Image.asset(
                                                                                  "assets/images/shopping.png",
                                                                                  height: 35,
                                                                                  width: 35,
                                                                                ),
                                                                                const SizedBox(width: 10),
                                                                                Text(
                                                                                  "Shopping",
                                                                                  style: TextStyle(fontSize: fontSize),
                                                                                )
                                                                              ],
                                                                            )
                                                                          ],
                                                                        ),
                                                                        Column(
                                                                          crossAxisAlignment:
                                                                              CrossAxisAlignment.start,
                                                                          children: [
                                                                            Row(
                                                                              children: [
                                                                                Image.asset(
                                                                                  "assets/images/facilities.png",
                                                                                  height: 35,
                                                                                  width: 35,
                                                                                ),
                                                                                const SizedBox(width: 10),
                                                                                Text(
                                                                                  "Facilities",
                                                                                  style: TextStyle(fontSize: fontSize),
                                                                                )
                                                                              ],
                                                                            ),
                                                                            const SizedBox(
                                                                              height: 15,
                                                                            ),
                                                                            Row(
                                                                              children: [
                                                                                Image.asset(
                                                                                  "assets/images/utilities.png",
                                                                                  height: 35,
                                                                                  width: 35,
                                                                                ),
                                                                                const SizedBox(width: 10),
                                                                                Text(
                                                                                  "Utilities",
                                                                                  style: TextStyle(fontSize: fontSize),
                                                                                )
                                                                              ],
                                                                            )
                                                                          ],
                                                                        )
                                                                      ]),
                                                                  const SizedBox(
                                                                    height: 20,
                                                                  ),
                                                                  Text(
                                                                    "Recent Searches",
                                                                    style: TextStyle(
                                                                        fontSize:
                                                                            fontSize,
                                                                        fontStyle:
                                                                            FontStyle.italic),
                                                                  ),
                                                                  const SizedBox(
                                                                    height: 40,
                                                                  ),

                                                                  searchItem(
                                                                      fontSize,
                                                                      "Baker Street",
                                                                      "Level 4, Security Hold Area"),
                                                                  const SizedBox(
                                                                    height: 15,
                                                                  ),
                                                                  searchItem(
                                                                      fontSize,
                                                                      "Baker Street",
                                                                      "Level 4, Security Hold Area"),

                                                                  const SizedBox(
                                                                    height: 15,
                                                                  ),
                                                                  searchItem(
                                                                      fontSize,
                                                                      "Baker Street",
                                                                      "Level 4, Security Hold Area"),
                                                                  const SizedBox(
                                                                    height: 15,
                                                                  ),
                                                                  searchItem(
                                                                      fontSize,
                                                                      "Baker Street",
                                                                      "Level 4, Security Hold Area"),
                                                                  const SizedBox(
                                                                    height: 15,
                                                                  ),
                                                                  searchItem(
                                                                      fontSize,
                                                                      "Baker Street",
                                                                      "Level 4, Security Hold Area"),
                                                                  const SizedBox(
                                                                    height: 15,
                                                                  ),
                                                                  searchItem(
                                                                      fontSize,
                                                                      "Baker Street",
                                                                      "Level 4, Security Hold Area"),
                                                                  const SizedBox(
                                                                    height: 15,
                                                                  ),
                                                                  searchItem(
                                                                      fontSize,
                                                                      "Baker Street",
                                                                      "Level 4, Security Hold Area"),
                                                                  const SizedBox(
                                                                    height: 15,
                                                                  ),
                                                                ],
                                                              ),
                                                            ),
                                                          ),
                                                        ],
                                                      ),
                                                      if (searchList != null &&
                                                          searchList.length > 0)
                                                        Container(
                                                          // height: double.minPositive,
                                                          height: height * 0.87,
                                                          color: Colors.white,
                                                          child:
                                                              ListView.builder(
                                                                  itemCount:
                                                                      searchList
                                                                          .length,
                                                                  itemBuilder:
                                                                      (BuildContext
                                                                              context,
                                                                          int index) {
                                                                    return Container(
                                                                      padding: EdgeInsets.symmetric(
                                                                          vertical:
                                                                              8,
                                                                          horizontal:
                                                                              10),
                                                                      child:
                                                                          Column(
                                                                        children: [
                                                                          Row(
                                                                            children: [
                                                                              Icon(
                                                                                Icons.supervised_user_circle,
                                                                                size: 40,
                                                                              ),
                                                                              Padding(
                                                                                padding: const EdgeInsets.only(left: 12.0),
                                                                                child: Column(
                                                                                  mainAxisSize: MainAxisSize.min,
                                                                                  crossAxisAlignment: CrossAxisAlignment.start,
                                                                                  children: [
                                                                                    Text(
                                                                                      "${searchList[index].poiMultilingual!.en!.name}",
                                                                                      style: TextStyle(fontWeight: FontWeight.bold),
                                                                                    ),
                                                                                    Text("${searchList[index].subcategory}")
                                                                                  ],
                                                                                ),
                                                                              )
                                                                            ],
                                                                          ),
                                                                          Divider(
                                                                            thickness:
                                                                                1,
                                                                          )
                                                                        ],
                                                                      ),
                                                                    );
                                                                  }),
                                                        ),
                                                    ],
                                                  ),
                                                ],
                                              );
                                            }));
                                  }),
                            ],
                          ),
                  ),
                ],
              ),
            )),
    );
  }

  Widget searchItem(fontSize, String propName, String propAddress) {
    return Row(
      mainAxisAlignment: MainAxisAlignment.start,
      children: [
        Image.asset(
          "assets/images/restro2.png",
          height: 30,
          width: 30,
        ),
        const SizedBox(width: 10),
        Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            Text(
              propName,
              style: TextStyle(fontSize: fontSize),
            ),
            Text(
              propAddress,
              style: const TextStyle(fontSize: 10),
            )
          ],
        ),
        const SizedBox(
          height: 20,
        )
      ],
    );
  }

  Widget _body(String URL) {
    return MapboxMap(
      accessToken: dotenv.env['MAPBOX_ACCESS_TOKEN'],
      initialCameraPosition:
          CameraPosition(target: LatLng(19.098519, 72.874318), zoom: 17),
      styleString: URL,
      compassEnabled: false,
      myLocationEnabled: true,
      onMapCreated: (MapboxMapController mapBoxController) {
        controller = mapBoxController;
        // isMapRead = true;

        print(">>>>>>>>>>>>>>>>>>>> 1074 >>>>>>>>    mapcreated");

        controller.onSymbolTapped.add((argument) {
          tappedaFunction(argument);
        });
      },
    );
  }
}
